/*                           BUSCANAT.COM

	 Programa que detecta el virus NATAS en archivos. !

		Compilado y enlazado en TC++ 1.0

	      El virus NATAS es un virus polimrfico que puede ser
       detectado de manera "facil" y "rpida" en los archivos,  si 
       la fecha del archivo es 100 a~os ms que la fecha original.  
       Esto implica que (a la fecha ctual), todo archivo que tenga 
       una fecha mayor que el ao 2080 aproximadamente, puede estar 
       infectado con el virus NATAS!.
	      El programa es muy ilustrativo,  y puede servir como 
       apoyo para todos los programadores que empiezen a introducirse 
       al mundo de los detectores/limpiadores de virus.

  IMPORTANTE! : 
	  No puede asegurarse que el programa detecte por completo
      en archivos posibles infecciones del NATAS. Adems, mientras
      que el virus se encuentre residente en memoria, no se podr
      detectar las infecciones hechas por este virus en archivos,
      el MBR o sector de carga.
	      Este mtodo solo es una alternativa para la deteccin
      del virus y no es la forma ms segura de encontrar al virus
      en los archivos, usted debe de apoyarse en mtodos ms seguros.

	El programa es de dominio pblico, por lo tanto, puede ser 
       modificado por cualquier programador. 

Autor  : Hctor Surez Barenca
E-mail : hsuarez@vmredipn.ipn.mx
Fecha  : 27/Ene/95
	    Nov/95

*/


#include <dir.h>
#include <stdio.h>

#define _IS_UPP         4                       /* is upper case */
#define _IS_LOW         8                       /* is lower case */
extern  char _CType _ctype[];                   /* Character type array */
int     _Cdecl isalpha (int __c);
#define isalpha(c)              (_ctype[(c) + 1] & (_IS_UPP | _IS_LOW))
#define toupper(c)              ((c) + 'A' - 'a')


void detecta()
{
struct ffblk ffblk;
int sig;

sig = findfirst("*.*",&ffblk,0x37);      // Busca Archivos, directorios, etc
while (!sig){
      if(ffblk.ff_attrib==0x10){        // Es un directorio?
	if(ffblk.ff_name[0]!='.'){
		chdir(ffblk.ff_name);   // Si, es un directorio!
		detecta();
		chdir("..");            // Pasa a un nivel mas alto
		}
      }else{                            // Es un archivo!
	printf("Verificando: %s ", ffblk.ff_name);
	if( ((ffblk.ff_fdate>>9)+1980)>2080)           // Infectado?
		puts("\x7 ==> Infectado con NATAS!!");
	else {putchar('');putchar('\n');}
	}
      sig = findnext(&ffblk);           // Siguiente archivo
   }
}


void main(char argc,char *argv[])
{
char diract[MAXPATH],disco;

puts("\n\n\t\tDetecta archivos infectados con el NATAS");
puts("Autor: Hctor Surez Barenca  ESIME/ICE-IPN\t1994-1995\n");
puts("\t\tAdvertencia!: Solo el virus en archivos\n");

diract[0] = '\\';
getcurdir(0,&diract[1]);                // Guarda la ruta actual
disco=(unsigned char)getdisk();         // Guarda la unidad actual
if(argc>1){
	setdisk(toupper(*argv[1])-'A');
	chdir(argv[1]);                 // Ruta a verificar
	}
detecta();                              // Empieza a detectar
setdisk(disco);                         // Unidad de disco original
chdir(diract);                          // Directorio original
return;
}
